DECLARE SUB box (xl%, yl%, xr%, yr%, testo%, sfondo%, ombra%)
DECLARE SUB FILEIN (nomein$, nca!, nca1$, ncc!, ncc1$, l!(), l1$(), Q!(), Q1$(), MS!(), MS1$(), MD!(), MD1$(), sy!, sy1$, sx!, sx1$, tratto!, nome$, taglio1$, delta!, delta1$, syt!, syt1$)
DECLARE SUB fileout (nomeout$, nca!, nca1$, ncc!, ncc1$, l!(), l1$(), Q!(), Q1$(), MS!(), MS1$(), MD!(), MD1$(), sy!, sy1$, sx!, sx1$, tratto!, nome$, taglio1$, delta!, delta1$, syt!, syt1$)
DECLARE SUB gettext (xl%, yl%, xr%, yr%, buf%())
DECLARE SUB help ()
DECLARE SUB inputdati (riga!, colinf!, colsup!, varnum!, varnum1$, file1$, varstring$, PRIMO!, SECONDO!, scelta!)
DECLARE SUB linea (a1!, b1!, a2!, b2!)
DECLARE FUNCTION monocromatico% ()
DECLARE SUB pagina1 (PAG1!, PAG2!, PAG3!, PAG4!, pag5!, varinput$, VAROUTPUT$, nomein$, nomeout$, testo!, sfondo!, errore!, aprifile!, tempo$, tempor%)
DECLARE SUB pagina2 (PAG1!, PAG2!, PAG3!, PAG4!, pag5!, nca!, nca1$, ncc!, ncc1$, PRIMO!, SECONDO!, testo!, sfondo!)
DECLARE SUB pagina3 (PAG1!, PAG2!, PAG3!, PAG4!, pag5!, l!(), l1$(), nca!, PRIMO!, SECONDO!, testo!, sfondo!)
DECLARE SUB pagina4 (PAG1!, PAG2!, PAG3!, PAG4!, pag5!, pag5UP!, nca!, ncc!, Q!(), MS!(), MD!(), Q1$(), MS1$(), MD1$(), PRIMO!, SECONDO!, testo!, sfondo!)
DECLARE SUB pagina5 (PAG1!, PAG2!, PAG3!, PAG4!, pag5!, pag5UP!, sx!, sx1$, sy!, sy1$, nome$, PRIMO!, SECONDO!, testo!, sfondo!, errore!, tratto$, taglio1$, delta!, delta1$, syt!, syt1$)
DECLARE SUB PARABOLE (Q!(), MS!(), MD!(), l!(), nca!, ncc!, sx!, sy!, nome$, tratto$, taglio1$, delta!, syt!, tempo$)
DECLARE SUB puttext (xl%, yl%, xr%, yr%, buf%())
DECLARE SUB TASTI ()




'
'                                     MOMCAD.BAS
'
'                PROGRAMMA PER IL TRACCIAMENTO DEI DIAGRAMMI DEL MOMENTO
'                E DEL TAGLIO DI UNA TRAVE (MAX 19 CAMPATE) CON  AUTOCAD
'
'

CONST CANC = 83, inser = 82, fine = 79, HOME = 71, FUP = 72, FDOWN = 80
CONST FLEFT = 75, FRIGHT = 77, PAGEUP = 73, PAGEDOWN = 81, backspace = 8
CONST INVIO = 13, ESC = 27, SPACE = 32, F1 = 59, F2 = 60, F3 = 61, F4 = 62
CONST F5 = 63, F6 = 64, F7 = 65, F8 = 66, F9 = 67, F10 = 68, F11 = 133
CONST F12 = 134, TRUE = 1, FALSE = 0
OPTION BASE 1
DIM Q(19, 57), MS(19, 57), MD(19, 57), Q1$(19, 57), MS1$(19, 57), MD1$(19, 57), l(19), l1$(19)
taglio1$ = "S"
testo = 15
sfondo = monocromatico + 1
tratto$ = "S"
ON ERROR GOTO gesterr
DO
  PAG1 = TRUE
  PAG2 = TRUE
  PAG3 = TRUE
  PAG4 = TRUE
  pag5 = TRUE
  pag5UP = TRUE
  DO
    errore = 0
inizio:
    CALL pagina1(PAG1, PAG2, PAG3, PAG4, pag5, varinput$, VAROUTPUT$, nomein$, nomeout$, testo, sfondo, errore, aprifile, tempo$, tempor%)
    IF varinput$ = "S" THEN
      errore = 1
      OPEN nomein$ + ".cad" FOR INPUT AS #1
      CLOSE 1
      errore = 0
    END IF
    IF VAROUTPUT$ = "S" THEN
      errore = 2
      OPEN nomeout$ + ".cad" FOR INPUT AS #1
      CLOSE 1
      errore = 0
    END IF
    IF varinput$ = "S" AND aprifile = 1 THEN
      CALL FILEIN(nomein$, nca, nca1$, ncc, ncc1$, l(), l1$(), Q(), Q1$(), MS(), MS1$(), MD(), MD1$(), sy, sy1$, sx, sx1$, tratto, nome$, taglio1$, delta, delta1$, syt, syt1$)
    END IF
    CALL pagina2(PAG1, PAG2, PAG3, PAG4, pag5, nca, nca1$, ncc, ncc1$, PRIMO, SECONDO, testo, sfondo)
    CALL pagina3(PAG1, PAG2, PAG3, PAG4, pag5, l(), l1$(), nca, PRIMO, SECONDO, testo, sfondo)
    CALL pagina4(PAG1, PAG2, PAG3, PAG4, pag5, pag5UP, nca, ncc, Q(), MS(), MD(), Q1$(), MS1$(), MD1$(), PRIMO, SECONDO, testo, sfondo)
inizio1:
    CALL pagina5(PAG1, PAG2, PAG3, PAG4, pag5, pag5UP, sx, sx1$, sy, sy1$, nome$, PRIMO, SECONDO, testo, sfondo, errore, tratto$, taglio1$, delta, delta1$, syt, syt1$)
    IF PRIMO = 0 AND SECONDO <> PAGEUP THEN
      errore = 3
      OPEN nome$ + ".DXB" FOR BINARY AS #1
      CLOSE 1
      errore = 0
    END IF
  LOOP UNTIL PRIMO = 0 AND SECONDO = PAGEDOWN
  LOCATE 22, 31, 0: PRINT " Attendere Prego ";
  IF VAROUTPUT$ = "S" THEN
    CALL fileout(nomeout$, nca, nca1$, ncc, ncc1$, l(), l1$(), Q(), Q1$(), MS(), MS1$(), MD(), MD1$(), sy, sy1$, sx, sx1$, tratto, nome$, taglio1$, delta, delta1$, syt, syt1$)
  END IF
  CALL PARABOLE(Q(), MS(), MD(), l(), nca, ncc, sx, sy, nome$, tratto$, taglio1$, delta, syt, tempo$)
  tempor% = 1
LOOP UNTIL 0
END
gesterr:
  SELECT CASE ERR
    CASE 64, 52
        SOUND 500, 2
        LOCATE 21, 27, 0: PRINT " Nome di file non valido  ";
        CALL TASTI
        SELECT CASE errore
          CASE 1, 2: RESUME inizio
          CASE 3: RESUME inizio1
          CASE ELSE: RESUME NEXT
        END SELECT
    CASE 71
        SOUND 500, 2
        LOCATE 21, 31, 0: PRINT " Disco non pronto ";
        CALL TASTI
        SELECT CASE errore
          CASE 1, 2: RESUME inizio
          CASE 3: RESUME inizio1
          CASE ELSE: RESUME NEXT
        END SELECT
    CASE 61
        SOUND 500, 2
        LOCATE 21, 33, 0: PRINT " Disco pieno ";
        CALL TASTI
        SELECT CASE errore
          CASE 1, 2: RESUME inizio
          CASE 3: RESUME inizio1
          CASE ELSE: RESUME NEXT
        END SELECT
    CASE 75
        SOUND 500, 2
        LOCATE 21, 14, 0: PRINT " Errore di accesso al percorso di ricerca del file ";
        CALL TASTI
        SELECT CASE errore
          CASE 1, 2: RESUME inizio
          CASE 3: RESUME inizio1
          CASE ELSE: RESUME NEXT
        END SELECT
    CASE 53
        IF errore = 2 OR errore = 3 THEN RESUME NEXT
        SOUND 500, 2
        LOCATE 21, 31, 0: PRINT " File non trovato ";
        CALL TASTI
        SELECT CASE errore
          CASE 1: RESUME inizio
          CASE ELSE: RESUME NEXT
        END SELECT
    CASE 76
        SOUND 500, 2
        LOCATE 21, 23, 0: PRINT " Percorso di ricerca non trovato ";
        CALL TASTI
        SELECT CASE errore
          CASE 1, 2: RESUME inizio
          CASE 3: RESUME inizio1
          CASE ELSE: RESUME NEXT
        END SELECT
    CASE ELSE
        ON ERROR GOTO 0
  END SELECT

' per usare l'ombra xr%<=78 e yr%<=24
SUB box (xl%, yl%, xr%, yr%, testo%, sfondo%, ombra%)
CONST ULCNR = 218, URCNR = 191, LLCNR = 192, LRCNR = 217, VTBAR = 179, HZBAR = 196

DEFINT B, I, L
  DEF SEG = 64
  DEF SEG = (47104 + 2048 * ((PEEK(16) AND 48) = 48))
  boxattr% = testo% + sfondo% * 16
  l = 160 * (yl% - 1) + 2 * (xl% - 1)
  POKE l, ULCNR: POKE l + 1, boxattr%
  l = 160 * (yr% - 1) + 2 * (xl% - 1)
  POKE l, LLCNR: POKE l + 1, boxattr%
  FOR i = xl% + 1 TO xr% - 1
    l = 160 * (yl% - 1) + 2 * (i - 1)
    POKE l, HZBAR: POKE l + 1, boxattr%
    l = 160 * (yr% - 1) + 2 * (i - 1)
    POKE l, HZBAR: POKE l + 1, boxattr%
  NEXT i
  l = 160 * (yl% - 1) + 2 * (xr% - 1)
  POKE l, URCNR: POKE l + 1, boxattr%
  l = 160 * (yr% - 1) + 2 * (xr% - 1)
  POKE l, LRCNR: POKE l + 1, boxattr%
  FOR i = yl% + 1 TO yr% - 1
    l = 160 * (i - 1) + 2 * (xl% - 1)
    POKE l, VTBAR: POKE l + 1, boxattr%
    l = 160 * (i - 1) + 2 * (xr% - 1)
    POKE l, VTBAR: POKE l + 1, boxattr%
  NEXT i
  IF ombra% = 0 THEN EXIT SUB
  FOR i = xl% + 2 TO xr% + 2
    POKE 160 * yr% + 2 * (i - 1) + 1, 8
  NEXT i
  FOR i = yl% + 1 TO yr%
    POKE 160 * (i - 1) + 2 * xr% + 1, 8
    POKE 160 * (i - 1) + 2 * (xr% + 1) + 1, 8
  NEXT i
END SUB

DEFSNG B, I, L
SUB FILEIN (nomein$, nca, nca1$, ncc, ncc1$, l(), l1$(), Q(), Q1$(), MS(), MS1$(), MD(), MD1$(), sy, sy1$, sx, sx1$, tratto, nome$, taglio1$, delta, delta1$, syt, syt1$)
  OPEN nomein$ + ".cad" FOR INPUT AS #1
  INPUT #1, nca, nca1$, ncc, ncc1$
  FOR i = 1 TO nca
    INPUT #1, l(i), l1$(i)
  NEXT i
  FOR z = 1 TO ncc
    FOR i = 1 TO nca
      INPUT #1, Q(i, z), Q1$(i, z), MS(i, z), MS1$(i, z), MD(i, z), MD1$(i, z)
    NEXT i
  NEXT z
  INPUT #1, sy, sy1$, sx, sx1$, tratto, nome$, taglio1$, delta, delta1$, syt, syt1$
  CLOSE 1
END SUB

SUB fileout (nomeout$, nca, nca1$, ncc, ncc1$, l(), l1$(), Q(), Q1$(), MS(), MS1$(), MD(), MD1$(), sy, sy1$, sx, sx1$, tratto, nome$, taglio1$, delta, delta1$, syt, syt1$)
  OPEN nomeout$ + ".cad" FOR OUTPUT AS #1
  PRINT #1, nca; ","; nca1$; ","; ncc; ","; ncc1$; ",";
  FOR i = 1 TO nca
    PRINT #1, l(i); ","; l1$(i); ",";
  NEXT i
  FOR z = 1 TO ncc
    FOR i = 1 TO nca
      PRINT #1, Q(i, z); ","; Q1$(i, z); ","; MS(i, z); ","; MS1$(i, z); ","; MD(i, z); ","; MD1$(i, z); ",";
    NEXT i
  NEXT z
  PRINT #1, sy; ","; sy1$; ","; sx; ","; sx1$; ","; tratto; ","; nome$; ","; taglio1$; ","; delta; ","; delta1$; ","; syt; ","; syt1$; ",";
  PRINT #1, "EOF";
  CLOSE 1

END SUB

SUB gettext (xl%, yl%, xr%, yr%, buf%())
DEFINT I-L
  DEF SEG = 64
  DEF SEG = (47104 + 2048 * ((PEEK(16) AND 48) = 48))
  k = 1
  FOR i = yl% TO yr%
  FOR j = xl% TO xr%
    l = 160 * (i - 1) + 2 * (j - 1)
    buf%(k) = PEEK(l) + PEEK(l + 1) * 256
    k = k + 1
  NEXT j, i
END SUB

DEFSNG I-L
'LIMITI SCHERMO TESTO HELP (COLONNA,RIGA) :(17,5)-(64,19)
SUB help

  DIM buf(1 TO 2000) AS INTEGER
  CALL gettext(16, 4, 67, 21, buf())
  CALL box(16, 4, 65, 20, 0, 7, 1)
  COLOR 0, 15
  LOCATE 4, 37, 0: PRINT " Help ";
  LOCATE 20, 57, 0: PRINT "F1";
  k = 0
  DO
    k = k + 1
    SELECT CASE k
      CASE 1
          COLOR 0, 15
          LOCATE 20, 60, 0: PRINT "Pag" + CHR$(25)
          LOCATE 5, 17, 0: PRINT "                                                "
          LOCATE 6, 17, 0: PRINT "                  MOMCAD.EXE                    "
          LOCATE 7, 17, 0: PRINT "                                                "
          LOCATE 8, 17, 0: PRINT "Programma per la creazione di un file <nome.DXB>"
          LOCATE 9, 17, 0: PRINT "interfacciabile con AUTOCAD  per il disegno  dei"
          LOCATE 10, 17, 0: PRINT "Diagrammi del Momento e del Taglio di una  trave"
          LOCATE 11, 17, 0: PRINT "(max 19 campate)in scala. Entrando  in  AUTOCAD "
          LOCATE 12, 17, 0: PRINT "con l'opzione 1 si crea un nuovo disegno e digi-"
          LOCATE 13, 17, 0: PRINT "tando il comando DXBIN si inserisce il nome  del"
          LOCATE 14, 17, 0: PRINT "file con estensione  DXB  creato con questo pro-"
          LOCATE 15, 17, 0: PRINT "gramma; cosi facendo AUTOCAD crea il disegno dei"
          LOCATE 16, 17, 0: PRINT "Diagrammi  del Momento-Taglio. Per stamparlo  in"
          LOCATE 17, 17, 0: PRINT "perfetta scala tarare la stampante grafica  o il"
          LOCATE 18, 17, 0: PRINT "plotter inserendo come fattore di scala:        "
          LOCATE 19, 17, 0: PRINT "         10 Millimetri=1 Unit Grafica          "
      CASE 2
          LOCATE 20, 60, 0: PRINT "Pag" + CHR$(24)
          COLOR 0, 15
          LOCATE 5, 17, 0: PRINT "Per vedere il disegno sul video usare il comando"
          LOCATE 6, 17, 0: PRINT " ZOOM  scegliendo l'opzione E  (zoom estensione)"
          LOCATE 7, 17, 0: PRINT "I dati di Input del programma sono:             "
          LOCATE 8, 17, 0: PRINT "  1) numero  delle  campate  della Trave        "
          LOCATE 9, 17, 0: PRINT "  2) numero delle  condizioni  di carico        "
          LOCATE 10, 17, 0: PRINT "     della trave                                "
          LOCATE 11, 17, 0: PRINT "  3) luci delle campate                         "
          LOCATE 12, 17, 0: PRINT "  4) per ogni condizione di carico e per        "
          LOCATE 13, 17, 0: PRINT "     ogni campata della Trave :                 "
          LOCATE 14, 17, 0: PRINT "      a) Carico ripartito                       "
          LOCATE 15, 17, 0: PRINT "         (positivo se diretto verso il basso)   "
          LOCATE 16, 17, 0: PRINT "      b) Momento a sinistra della campata       "
          LOCATE 17, 17, 0: PRINT "         (positivo se tende le fibre inferiori) "
          LOCATE 18, 17, 0: PRINT "      c) Momento a destra della campata         "
          LOCATE 19, 17, 0: PRINT "         (positivo se tende le fibre inferiori) "
    END SELECT
    DO
      DO
        a$ = INKEY$
      LOOP UNTIL a$ <> ""
      PRIMO = ASC(LEFT$(a$, 1))
      SECONDO = ASC(RIGHT$(a$, 1))
      filtro$ = CHR$(F1) + CHR$(PAGEDOWN) + CHR$(PAGEUP)
      IF PRIMO = 0 AND INSTR(filtro$, RIGHT$(a$, 1)) = 0 OR PRIMO <> 0 THEN
        SOUND 500, 2
      ELSE
        EXIT DO
      END IF
    LOOP UNTIL 0
    IF PRIMO = 0 AND SECONDO = PAGEDOWN THEN
       IF k = 2 THEN
         SOUND 500, 2
         k = 1
       END IF
    ELSEIF PRIMO = 0 AND SECONDO = PAGEUP THEN
      IF k = 1 THEN
        SOUND 500, 2
        k = 0
      ELSE
        k = 0
      END IF
    END IF
  LOOP UNTIL PRIMO = 0 AND SECONDO = F1
  CALL puttext(16, 4, 67, 21, buf())
END SUB

SUB inputdati (riga, colinf, colsup, varnum, varnum1$, file1$, varstring$, PRIMO, SECONDO, scelta)

' scelta = 1 input di una variabile numerica(varnum,varnum1$)
' scelta = 2 input del nome di un file(file1$)
' scelta = 3 input di una stringa generica(varstring$)

  FOR i = colinf TO colsup
    LOCATE riga, i, 0: PRINT "";
  NEXT i
  SELECT CASE scelta
    CASE 1
        IF varnum1$ <> "" THEN
          LOCATE riga, colinf, 0: PRINT varnum1$;
        END IF
    CASE 2
        LOCATE riga, colinf, 0: PRINT file1$;
    CASE 3
        LOCATE riga, colinf, 0: PRINT varstring$;
  END SELECT
  LOCATE riga, colinf, 1, 12, 14
  z = 2
  w = 12
  DO
    DO
      DO
        controllo = TRUE
        LOCATE , , 1, w, 14
        DO
          a$ = INKEY$
        LOOP UNTIL a$ <> ""
        PRIMO = ASC(LEFT$(a$, 1))
        SECONDO = ASC(RIGHT$(a$, 1))
        SELECT CASE scelta
          CASE 1
              filtro$ = "0123456789.-" + CHR$(SPACE)
              filtro1$ = CHR$(CANC) + CHR$(inser) + CHR$(fine) + CHR$(HOME) + CHR$(FLEFT) + CHR$(FRIGHT) + CHR$(FDOWN) + CHR$(FUP) + CHR$(PAGEDOWN) + CHR$(PAGEUP) + CHR$(F1)
              filtro2$ = filtro$ + CHR$(backspace) + CHR$(INVIO) + CHR$(ESC)
              IF PRIMO = 0 AND INSTR(filtro1$, RIGHT$(a$, 1)) = 0 OR PRIMO <> 0 AND INSTR(filtro2$, a$) = 0 THEN
                SOUND 500, 2
                controllo = FALSE
              END IF
          CASE 2
              filtro$ = "ABCDEFGHILMNOPQRSTUVZWYJKXabcdefghilmnopqrstuvzwyjkx:\12345678903"
              filtro1$ = CHR$(CANC) + CHR$(inser) + CHR$(fine) + CHR$(HOME) + CHR$(FLEFT) + CHR$(FRIGHT) + CHR$(FDOWN) + CHR$(FUP) + CHR$(PAGEDOWN) + CHR$(PAGEUP) + CHR$(F1)
              filtro2$ = CHR$(SPACE) + CHR$(backspace) + CHR$(INVIO) + CHR$(ESC)
              filtro3$ = filtro$ + filtro2$
              IF PRIMO = 0 AND INSTR(filtro1$, RIGHT$(a$, 1)) = 0 OR PRIMO <> 0 AND INSTR(filtro3$, a$) = 0 THEN
                SOUND 500, 2
                controllo = FALSE
              END IF
          CASE 3
              filtro$ = "ABCDEFGHILMNOPQRSTUVZWYJKXabcdefghilmnopqrstuvzwyjkx"
              filtro1$ = CHR$(CANC) + CHR$(inser) + CHR$(fine) + CHR$(HOME) + CHR$(FLEFT) + CHR$(FRIGHT) + CHR$(FDOWN) + CHR$(FUP) + CHR$(PAGEDOWN) + CHR$(PAGEUP) + CHR$(F1)
              filtro2$ = CHR$(SPACE) + CHR$(backspace) + CHR$(INVIO) + CHR$(ESC)
              filtro3$ = filtro$ + filtro2$
              IF (PRIMO = 0 AND INSTR(filtro1$, RIGHT$(a$, 1)) = 0) OR (PRIMO < 32 AND PRIMO > 0 AND INSTR(filtro2$, a$) = 0) THEN
                SOUND 500, 2
                controllo = FALSE
              END IF
        END SELECT
      LOOP UNTIL controllo
      controllo = FALSE
      SELECT CASE PRIMO
        CASE INVIO, ESC
            controllo = TRUE
        CASE backspace
            IF POS(0) > colinf THEN
              LOCATE CSRLIN, POS(0), 0
              a = POS(0) - 1
              FOR i = POS(0) TO colsup
                LOCATE CSRLIN, i - 1, 0
                PRINT CHR$(SCREEN(CSRLIN, i));
              NEXT i
              LOCATE CSRLIN, colsup, 0: PRINT "";
              LOCATE CSRLIN, a, 1, w, 14
            END IF
        CASE SPACE
            IF POS(0) <= colsup AND w = 12 AND POS(0) >= colinf THEN
              PRINT "";
              IF POS(0) > colsup THEN
                LOCATE CSRLIN, colsup, 1, w, 14
              END IF
            ELSEIF POS(0) <= colsup AND w = 1 AND POS(0) >= colinf THEN
              LOCATE CSRLIN, POS(0), 0
              a = POS(0)
              FOR i = colsup - 1 TO POS(0) STEP -1
                LOCATE CSRLIN, i + 1, 0
                PRINT CHR$(SCREEN(CSRLIN, i));
              NEXT i
              LOCATE CSRLIN, a, 0
              PRINT "";
              IF POS(0) > colsup THEN
                LOCATE CSRLIN, colsup, 1, w, 14
              END IF
            END IF
        CASE 0
          SELECT CASE SECONDO
            CASE PAGEDOWN, PAGEUP, FDOWN, FUP, F1: controllo = TRUE
            CASE inser
                z = z + 1
                IF INT(z / 2) = z / 2 THEN
                  w = 12
                ELSE
                  w = 1
                END IF
            CASE FLEFT
                IF POS(0) > colinf THEN
                  LOCATE CSRLIN, POS(0) - 1
                ELSEIF POS(0) = colinf THEN
                  PRINT "";
                END IF
            CASE FRIGHT
                IF POS(0) < colsup THEN
                  LOCATE CSRLIN, POS(0) + 1
                ELSEIF POS(0) = colsup THEN
                  PRINT "";
                END IF
            CASE CANC
                a = POS(0)
                FOR i = POS(0) + 1 TO colsup
                  LOCATE CSRLIN, i - 1, 0
                  PRINT CHR$(SCREEN(CSRLIN, i));
                NEXT i
                LOCATE CSRLIN, colsup, 0: PRINT "";
                LOCATE CSRLIN, a, 1, w, 14
            CASE HOME
                a = colinf
                FOR i = colinf TO colsup
                  u$ = CHR$(SCREEN(riga, i))
                  IF u$ <> "" THEN
                    a = i
                    EXIT FOR
                  END IF
                NEXT i
                LOCATE riga, a
            CASE fine
                a = colinf
                FOR i = colsup TO colinf STEP -1
                  u$ = CHR$(SCREEN(riga, i))
                  IF u$ <> "" THEN
                    a = i
                    EXIT FOR
                  END IF
                NEXT i
                LOCATE riga, a
          END SELECT
        CASE ELSE
            IF POS(0) <= colsup AND POS(0) >= colinf THEN
              IF w = 1 THEN
                LOCATE CSRLIN, POS(0), 0
                a = POS(0)
                FOR i = colsup - 1 TO POS(0) STEP -1
                  LOCATE CSRLIN, i + 1, 0
                  PRINT CHR$(SCREEN(CSRLIN, i));
                NEXT i
                LOCATE CSRLIN, a, 0
              END IF
              PRINT CHR$(PRIMO);
              IF POS(0) > colsup THEN
                LOCATE CSRLIN, colsup, 1, w, 14
              END IF
            END IF
      END SELECT
    LOOP UNTIL controllo
    controllo = TRUE
    SELECT CASE scelta
      CASE 2, 3
          temp$ = ""
          temp1$ = ""
          FOR i = colinf TO colsup
            a$ = CHR$(SCREEN(riga, i))
            IF INSTR(a$, "") = 0 AND INSTR(a$, " ") = 0 THEN
              temp$ = temp$ + a$
            ELSEIF INSTR(a$, "") <> 0 THEN
              a$ = " "
            END IF
            temp1$ = temp1$ + a$
          NEXT i
          IF cont1 > 1 OR cont2 > 1 THEN
            SOUND 500, 2
            controllo = FALSE
          END IF
          FOR i = colinf TO colsup
            LOCATE riga, i, 0: PRINT "";
          NEXT i
          LOCATE riga, colinf, 0:
          IF scelta = 2 THEN
            PRINT temp$;
          ELSEIF scelta = 3 THEN
            PRINT temp1$;
          END IF
          file1$ = temp$
          varstring$ = temp1$
          EXIT SUB
      CASE 1
          cont1 = 0
          cont2 = 0
          temp$ = ""
          FOR i = colinf TO colsup
            a$ = CHR$(SCREEN(riga, i))
            IF a$ = "-" THEN
              cont1 = cont1 + 1
              IF a$ = "-" AND cont1 = 1 AND i > colinf THEN
                FOR z = colinf TO i - 1
                  var$ = CHR$(SCREEN(riga, z))
                  IF var$ <> "" THEN
                    SOUND 500, 2
                    controllo = FALSE
                  END IF
                NEXT z
              END IF
            ELSEIF a$ = "." THEN
              cont2 = cont2 + 1
            END IF
            IF INSTR(filtro$, a$) <> 0 THEN
              temp$ = temp$ + a$
            END IF
          NEXT i
          IF cont1 > 1 OR cont2 > 1 THEN
            SOUND 500, 2
            controllo = FALSE
          END IF
    END SELECT
  LOOP UNTIL controllo
  LOCATE riga, colinf, 0: PRINT temp$
  FOR i = colinf + LEN(temp$) TO colsup
    LOCATE riga, i, 0: PRINT "";
  NEXT i
  varnum1$ = temp$
  varnum = VAL(temp$)
  IF varnum = 0 THEN
    LOCATE riga, colinf, 0
    PRINT "0";
    varnum1$ = "0"
  END IF
END SUB

SUB linea (a1, b1, a2, b2)

CONST SUP = 327.675
STATIC nmode AS INTEGER
DEFINT X
DEFDBL Y
  IF (ABS(a1) < SUP AND ABS(b1) < SUP AND ABS(a2) < SUP AND ABS(b2) < SUP) THEN
    IF nmode THEN
      c$ = CHR$(135) + CHR$(0) + CHR$(0) + CHR$(1)
      nmode = 0
    ELSE
      c$ = CHR$(1)
    END IF
    PUT #1, , c$
    x = INT(a1 * 100 + .5): PUT #1, , x
    x = INT(b1 * 100 + .5): PUT #1, , x
    x = INT(a2 * 100 + .5): PUT #1, , x
    x = INT(b2 * 100 + .5): PUT #1, , x
  ELSE
    IF NOT nmode THEN
      c$ = CHR$(135) + CHR$(1) + CHR$(0) + CHR$(1)
      nmode = -1
    ELSE
      c$ = CHR$(1)
    END IF
    PUT #1, , c$
    y = a1: PUT #1, , y
    y = b1: PUT #1, , y
    y = a2: PUT #1, , y
    y = b2: PUT #1, , y
  END IF

END SUB

DEFSNG X-Y
FUNCTION monocromatico%
  DEF SEG = 64
  monocromatico% = ((PEEK(16) AND 48) = 48)
END FUNCTION

SUB pagina1 (PAG1, PAG2, PAG3, PAG4, pag5, varinput$, VAROUTPUT$, nomein$, nomeout$, testo, sfondo, errore, aprifile, tempo$, tempor%)
aprifile = 0
DO WHILE PAG1
  aprifile = 1
  PAG1 = FALSE
  COLOR testo, sfondo
  CLS
  LOCATE 5, 12, 0: PRINT "PROGRAMMA PER IL TRACCIAMENTO DEI DIAGRAMMI DEL MOMENTO"
  LOCATE 6, 12, 0: PRINT "E DEL TAGLIO DI UNA TRAVE (MAX 19 CAMPATE)  CON AUTOCAD "
  COLOR 0, 15
  LOCATE 2, 36, 0: PRINT " MOMCAD ";
  LOCATE 10, 5, 0: PRINT " Vuoi utilizzare dati registrati in un file [S/N]: ";
  LOCATE 14, 5, 0: PRINT " Vuoi registrare i dati di input in un file [S/N]: ";
  LOCATE 12, 5, 0: PRINT " Se SI'inserisci il nome del file .CAD: ";
  LOCATE 16, 5, 0: PRINT " Se SI'inserisci il nome del file .CAD: ";
  LOCATE 25, 3, 0: PRINT " ESC ";
  LOCATE 25, 10, 0: PRINT " F1 ";
  LOCATE 25, 16, 0: PRINT " Pag" + CHR$(25); " ";
  LOCATE 10, 58, 0: PRINT "";
  LOCATE 10, 58, 0: PRINT varinput$;
  LOCATE 12, 47, 0: PRINT "";
  LOCATE 12, 47, 0: PRINT nomein$;
  LOCATE 14, 58, 0: PRINT "";
  LOCATE 14, 58, 0: PRINT VAROUTPUT$;
  LOCATE 16, 47, 0: PRINT "";
  LOCATE 16, 47, 0: PRINT nomeout$;
  IF tempor% = 1 THEN
    LOCATE 20, 19, 0: PRINT " Tempo Di Elaborazione [h:m:s] = "; tempo$; " ";
    a$ = INPUT$(1)
    COLOR testo, sfondo
    LOCATE 20, 19, 0: PRINT "                                              ";
    COLOR 0, 15
    tempor% = 0
  END IF
  k = 0
  DO
    k = k + 1
    IF errore = 1 THEN
      k = 2
    ELSEIF errore = 2 THEN
      k = 4
    END IF
    errore = 0
    SELECT CASE k
      CASE 1
          DO
            CALL inputdati(10, 58, 58, varnum, varnum1$, varinput$, varstring$, PRIMO, SECONDO, 2)
            IF PRIMO = ESC THEN COLOR 15, 0: CLS : SYSTEM
            varinput$ = UCASE$(varinput$)
            IF varinput$ <> "S" AND varinput$ <> "N" AND (PRIMO OR SECONDO <> F1) THEN
              SOUND 500, 2
              varinput$ = ""
              LOCATE 10, 58, 0: PRINT "";
            END IF
          LOOP UNTIL varinput$ = "S" OR varinput$ = "N" OR PRIMO = 0 AND SECONDO = F1
          IF varinput$ = "N" THEN
            LOCATE 12, 47, 0: PRINT "";
            k = k + 1: nomein$ = ""
          END IF
      CASE 2
          CALL inputdati(12, 47, 79, varnum, varnum1$, nomein$, varstring$, PRIMO, SECONDO, 2)
      CASE 3
          DO
            CALL inputdati(14, 58, 58, varnum, varnum1$, VAROUTPUT$, varstring$, PRIMO, SECONDO, 2)
            IF PRIMO = ESC THEN COLOR 15, 0: CLS : SYSTEM
            VAROUTPUT$ = UCASE$(VAROUTPUT$)
            IF VAROUTPUT$ <> "S" AND VAROUTPUT$ <> "N" AND (PRIMO OR SECONDO <> F1) THEN
              SOUND 500, 2
              VAROUTPUT$ = ""
              LOCATE 14, 58, 0: PRINT "";
            END IF
          LOOP UNTIL VAROUTPUT$ = "S" OR VAROUTPUT$ = "N" OR PRIMO = 0 AND SECONDO = F1
          IF VAROUTPUT$ = "N" THEN
            LOCATE 16, 47, 0: PRINT "";
            k = k + 1: nomeout$ = ""
          END IF
      CASE 4
          CALL inputdati(16, 47, 79, varnum, varnum1$, nomeout$, varstring$, PRIMO, SECONDO, 2)
    END SELECT
    SELECT CASE PRIMO
      CASE ESC
          COLOR 15, 0: CLS : SYSTEM
      CASE 0
      SELECT CASE SECONDO
        CASE F1
            CALL help
            k = k - 1
        CASE FUP
            IF k = 1 AND VAROUTPUT$ = "N" THEN
              k = 2
            ELSEIF k = 1 AND VAROUTPUT$ = "S" THEN
              k = 3
            ELSEIF k = 2 AND varinput$ = "S" THEN
              k = 0
            ELSEIF k = 2 AND varinput$ = "N" AND VAROUTPUT$ = "S" THEN
              k = 3
            ELSEIF k = 3 AND varinput$ = "N" THEN
              k = 0
            ELSEIF k = 3 AND varinput$ = "S" THEN
              k = 1
            ELSEIF k = 4 AND VAROUTPUT$ = "N" AND varinput$ = "S" THEN
              k = 1
            ELSEIF k = 4 AND VAROUTPUT$ = "S" THEN
              k = 2
            END IF
        CASE PAGEUP
            SOUND 500, 2
            k = k - 1
        CASE PAGEDOWN
            IF varinput$ = "S" AND nomein$ = "" THEN
              SOUND 500, 2
              k = 1
            ELSEIF VAROUTPUT$ = "S" AND nomeout$ = "" THEN
              SOUND 500, 2
              k = 3
            ELSEIF varinput$ <> "" AND VAROUTPUT$ <> "" THEN
              PAG1 = TRUE
              EXIT SUB
            END IF
      END SELECT
    END SELECT
    IF k = 4 THEN k = 0
  LOOP UNTIL 0
LOOP
PAG1 = TRUE
END SUB

SUB pagina2 (PAG1, PAG2, PAG3, PAG4, pag5, nca, nca1$, ncc, ncc1$, PRIMO, SECONDO, testo, sfondo)

  DO WHILE PAG2
    PAG2 = FALSE
    COLOR testo, sfondo
    CLS
    LOCATE 5, 12, 0: PRINT "PROGRAMMA PER IL TRACCIAMENTO DEI DIAGRAMMI DEL MOMENTO"
    LOCATE 6, 12, 0: PRINT "E DEL TAGLIO DI UNA TRAVE (MAX 19 CAMPATE)  CON AUTOCAD "
    COLOR 0, 15
    LOCATE 2, 36, 0: PRINT " MOMCAD ";
    LOCATE 25, 3, 0: PRINT " ESC ";
    LOCATE 25, 10, 0: PRINT " F1 ";
    LOCATE 25, 16, 0: PRINT " Pag" + CHR$(24); " ";
    LOCATE 25, 24, 0: PRINT " Pag" + CHR$(25); " ";
    LOCATE 14, 10, 0: PRINT "Inserisci il  numero   delle   Campate (max 19)";
    LOCATE 16, 10, 0: PRINT "Inserisci il n delle  Cond. di Carico (max 57)";
    LOCATE 14, 60, 0: PRINT "0";
    LOCATE 16, 60, 0: PRINT "0";
    LOCATE 14, 60, 0: PRINT nca1$;
    LOCATE 16, 60, 0: PRINT ncc1$;
    DO
      DO
        CALL inputdati(14, 60, 61, nca, nca1$, file1$, varstring$, PRIMO, SECONDO, 1)
        IF PRIMO = ESC THEN
          COLOR 7, 0: CLS : SYSTEM
        END IF
        IF PRIMO = 0 AND SECONDO = F1 THEN
          CALL help
        ELSEIF PRIMO = 0 AND SECONDO = PAGEUP THEN
          PAG3 = FALSE: PAG4 = FALSE: pag5 = FALSE: PAG2 = TRUE
          EXIT SUB
        ELSEIF PRIMO = 0 AND SECONDO <> F1 THEN
          IF nca = 0 OR nca > 19 THEN SOUND 500, 2
        END IF
      LOOP WHILE nca = 0 OR nca > 19
      IF PRIMO = 0 AND SECONDO = PAGEDOWN AND ncc > 0 AND ncc < 57 THEN
        EXIT DO
      ELSEIF ncc = 0 THEN
        IF PRIMO = INVIO OR (PRIMO = 0 AND (SECONDO = FUP OR SECONDO = FDOWN)) THEN
        ELSE
          SOUND 500, 2
        END IF
      END IF
      DO
        CALL inputdati(16, 60, 61, ncc, ncc1$, file1$, varstring$, PRIMO, SECONDO, 1)
        IF PRIMO = ESC THEN
          COLOR 7, 0: CLS : SYSTEM
        END IF
        IF PRIMO = 0 AND SECONDO = F1 THEN
          CALL help
        ELSEIF PRIMO = 0 AND SECONDO = PAGEUP THEN
          PAG3 = FALSE: PAG4 = FALSE: pag5 = FALSE: PAG2 = TRUE
          EXIT SUB
        ELSEIF PRIMO = 0 AND SECONDO <> F1 THEN
          IF ncc = 0 OR ncc > 57 THEN SOUND 500, 2
        END IF
      LOOP WHILE ncc = 0 OR ncc > 57
    LOOP UNTIL PRIMO = 0 AND SECONDO = PAGEDOWN
  LOOP
  PAG2 = TRUE
END SUB

SUB pagina3 (PAG1, PAG2, PAG3, PAG4, pag5, l(), l1$(), nca, PRIMO, SECONDO, testo, sfondo)

  DO WHILE PAG3
    PAG3 = FALSE
    COLOR testo, sfondo
    CLS
    COLOR 0, 15
    LOCATE 2, 27, 0: PRINT "  LUNGHEZZA DELLE CAMPATE  ";
    LOCATE 25, 3, 0: PRINT " ESC ";
    LOCATE 25, 10, 0: PRINT " F1 ";
    LOCATE 25, 16, 0: PRINT " Pag" + CHR$(24); " ";
    LOCATE 25, 24, 0: PRINT " Pag" + CHR$(25); " ";
    FOR i = 1 TO nca
      LOCATE i + 4, 16, 0: PRINT USING "Lunghezza Campata n ##  (mt) "; i;
      LOCATE i + 4, 50, 0: PRINT "0";
      LOCATE i + 4, 50, 0: PRINT l1$(i);
    NEXT i
    DO
      FOR i = 1 TO nca
      CALL inputdati(i + 4, 50, 56, l(i), l1$(i), file1$, varstring$, PRIMO, SECONDO, 1)
      SELECT CASE PRIMO
        CASE ESC
            COLOR 7, 0
            CLS
            SYSTEM
        CASE 0
        SELECT CASE SECONDO
          CASE PAGEDOWN
              EXIT DO
          CASE PAGEUP
              PAG4 = FALSE
              pag5 = FALSE
              PAG1 = FALSE
              EXIT DO
          CASE F1
              CALL help
              IF i = 1 THEN
                i = 0
              ELSE
                i = i - 1
              END IF
          CASE FUP
             IF i > 1 THEN
               i = i - 2
             ELSEIF i = 1 THEN
               i = nca - 1
             END IF
        END SELECT
      END SELECT
      NEXT i
    LOOP UNTIL PRIMO = 0 AND (SECONDO = PAGEDOWN OR SECONDO = PAGEUP)
  LOOP
  PAG3 = TRUE
END SUB

SUB pagina4 (PAG1, PAG2, PAG3, PAG4, pag5, pag5UP, nca, ncc, Q(), MS(), MD(), Q1$(), MS1$(), MD1$(), PRIMO, SECONDO, testo, sfondo)

  DO WHILE PAG4
    PAG4 = FALSE
    COLOR testo, sfondo
    CLS
    COLOR 0, 15
    LOCATE 1, 23, 0: PRINT "  CONDIZIONE DI CARICO NUMERO  1  "
    LOCATE 3, 3, 0: PRINT " CAMPATE "
    LOCATE 3, 28, 0: PRINT " Q(Kg/ml) "
    LOCATE 3, 50, 0: PRINT " MS (Kgm) "
    LOCATE 3, 70, 0: PRINT " MD (Kgm) "
    FOR i = 1 TO nca
      LOCATE i + 4, 1, 0: PRINT USING "Campata n ## "; i;
    NEXT i
    LOCATE 25, 3, 0: PRINT " ESC ";
    LOCATE 25, 10, 0: PRINT " F1 ";
    LOCATE 25, 16, 0: PRINT " Pag" + CHR$(24); " ";
    LOCATE 25, 24, 0: PRINT " Pag" + CHR$(25); " ";
    FOR z = 1 TO ncc
      IF pag5UP = FALSE THEN z = ncc
      pag5UP = TRUE
      DO
        LOCATE 1, 54: PRINT USING "##"; z;
        FOR i = 1 TO nca
          LOCATE i + 4, 30, 0: PRINT "0";
          LOCATE i + 4, 30, 0: PRINT Q1$(i, z);
          LOCATE i + 4, 52, 0: PRINT "0";
          LOCATE i + 4, 52, 0: PRINT MS1$(i, z);
          LOCATE i + 4, 72, 0: PRINT "0";
          LOCATE i + 4, 72, 0: PRINT MD1$(i, z);
        NEXT i
        FOR i = 1 TO nca
          LOCATE i + 4, 1, 0: PRINT USING "Campata n ## "; i;
          k = 0
          DO
            k = k + 1
            SELECT CASE k
              CASE 1: CALL inputdati(i + 4, 30, 37, Q(i, z), Q1$(i, z), file1$, varstring$, PRIMO, SECONDO, 1)
              CASE 2: CALL inputdati(i + 4, 52, 59, MS(i, z), MS1$(i, z), file1$, varstring$, PRIMO, SECONDO, 1)
              CASE 3: CALL inputdati(i + 4, 72, 79, MD(i, z), MD1$(i, z), file1$, varstring$, PRIMO, SECONDO, 1)
            END SELECT
            SELECT CASE PRIMO
              CASE ESC
                  COLOR 7, 0
                  CLS
                  SYSTEM
              CASE 0
              SELECT CASE SECONDO
                CASE PAGEUP
                    IF z > 1 THEN
                      z = z - 2
                      EXIT FOR
                    ELSEIF z = 1 THEN
                      z = ncc
                      PAG1 = FALSE
                      PAG2 = FALSE
                      pag5 = FALSE
                      EXIT FOR
                    END IF
                CASE PAGEDOWN
                    IF z < ncc THEN
                       EXIT FOR
                    ELSE
                       z = ncc
                       EXIT FOR
                    END IF
                CASE F1
                    CALL help
                    IF k = 1 THEN
                      k = 0
                    ELSE
                      k = k - 1
                    END IF
                CASE FUP
                   IF k > 1 THEN
                     k = k - 2
                   ELSEIF k = 1 AND i > 1 THEN
                     i = i - 1
                     k = 2
                   ELSEIF k = 1 AND i = 1 THEN
                     i = nca
                     k = 2
                   END IF
              END SELECT
            END SELECT
          LOOP UNTIL k = 3
        NEXT i
      LOOP UNTIL PRIMO = 0 AND (SECONDO = PAGEDOWN OR SECONDO = PAGEUP)
    NEXT z
  LOOP
PAG4 = TRUE
END SUB

SUB pagina5 (PAG1, PAG2, PAG3, PAG4, pag5, pag5UP, sx, sx1$, sy, sy1$, nome$, PRIMO, SECONDO, testo, sfondo, errore, tratto$, taglio1$, delta, delta1$, syt, syt1$)

  DO WHILE pag5
    pag5 = FALSE
    COLOR testo, sfondo
    CLS
    COLOR 0, 15
    IF taglio1$ = "S" THEN
      LOCATE 10, 60, 0: PRINT "0";
      LOCATE 10, 60, 0: PRINT syt1$;
      LOCATE 14, 60, 0: PRINT "0";
      LOCATE 14, 60, 0: PRINT delta1$;
    ELSE
      COLOR testo, sfondo
      LOCATE 10, 60, 0: PRINT "     ";
      LOCATE 14, 60, 0: PRINT "     ";
      COLOR 0, 15
    END IF
    LOCATE 8, 60, 0: PRINT "0";
    LOCATE 8, 60, 0: PRINT sy1$;
    LOCATE 12, 60, 0: PRINT "0";
    LOCATE 12, 60, 0: PRINT sx1$;
    LOCATE 16, 60, 0: PRINT "";
    LOCATE 16, 60, 0: PRINT tratto$;
    LOCATE 18, 29, 0: PRINT "";
    LOCATE 18, 29, 0: PRINT nome$;
    LOCATE 6, 2, 0: PRINT " Vuoi disegnare il Diagramma del Taglio        [s/n] = ";
    LOCATE 8, 2, 0: PRINT " Scala Momento                      [1 cm=Scala*Kgm] = ";
    LOCATE 10, 2, 0: PRINT " Scala Taglio                        [1 cm=Scala*kg] = ";
    LOCATE 12, 2, 0: PRINT " Scala Lunghezze                     [1 cm=Scala*cm] = ";
    LOCATE 14, 2, 0: PRINT " Distanza in Scala degli Assi dei due Diagrammi [cm] = ";
    LOCATE 16, 2, 0: PRINT " Vuoi i Diagrammi Tratteggiati                 [s/n] = ";
    LOCATE 18, 2, 0: PRINT " Nome File .DXB       = ";
    LOCATE 25, 3, 0: PRINT " ESC ";
    LOCATE 25, 10, 0: PRINT " F1 ";
    LOCATE 25, 16, 0: PRINT " Pag" + CHR$(24); " ";
    LOCATE 25, 24, 0: PRINT " Pag" + CHR$(25); " ";
    DO
      k = 0
      DO
        k = k + 1
        IF errore = 3 THEN k = 4
        errore = 0
        SELECT CASE k
          CASE 1: DO
                    CALL inputdati(6, 60, 60, varnum, varnum1$, file1$, taglio1$, PRIMO, SECONDO, 3)
                    taglio1$ = UCASE$(taglio1$)
                    IF taglio1$ <> "S" AND taglio1$ <> "N" THEN SOUND 500, 2
                    IF taglio1$ = "S" THEN
                      LOCATE 10, 60, 0: PRINT "0";
                      LOCATE 10, 60, 0: PRINT syt1$;
                      LOCATE 14, 60, 0: PRINT "0";
                      LOCATE 14, 60, 0: PRINT delta1$;
                    ELSE
                      COLOR testo, sfondo
                      LOCATE 10, 60, 0: PRINT "     ";
                      LOCATE 14, 60, 0: PRINT "     ";
                      COLOR 0, 15
                    END IF
                  LOOP UNTIL taglio1$ = "S" OR taglio1$ = "N"
          CASE 2: CALL inputdati(8, 60, 64, sy, sy1$, file1$, varstring$, PRIMO, SECONDO, 1)
          CASE 3: IF taglio1$ = "S" THEN CALL inputdati(10, 60, 64, syt, syt1$, file1$, varstring$, PRIMO, SECONDO, 1)
          CASE 4: CALL inputdati(12, 60, 64, sx, sx1$, file1$, varstring$, PRIMO, SECONDO, 1)
          CASE 5: IF taglio1$ = "S" THEN CALL inputdati(14, 60, 64, delta, delta1$, file1$, varstring$, PRIMO, SECONDO, 1)
          CASE 6: DO
                    CALL inputdati(16, 60, 60, varnum, varnum1$, file1$, tratto$, PRIMO, SECONDO, 3)
                    tratto$ = UCASE$(tratto$)
                    IF tratto$ <> "S" AND tratto$ <> "N" THEN SOUND 500, 2
                  LOOP UNTIL tratto$ = "S" OR tratto$ = "N"
          CASE 7: CALL inputdati(18, 29, 64, varnum, varnum1$, nome$, varstring$, PRIMO, SECONDO, 2)
        END SELECT
        SELECT CASE PRIMO
          CASE ESC
              COLOR 7, 0
              CLS
              SYSTEM
              CASE 0
          SELECT CASE SECONDO
            CASE PAGEUP
                PAG1 = FALSE
                PAG2 = FALSE
                PAG3 = FALSE
                pag5UP = FALSE
                pag5 = TRUE
                EXIT SUB
            CASE PAGEDOWN
                controllo = TRUE
                IF sy = 0 THEN
                  SOUND 500, 2: k = 0
                ELSEIF sx = 0 THEN
                  SOUND 500, 2: k = 1
                ELSEIF UCASE$(tratto$) <> "S" AND UCASE$(tratto$) <> "N" THEN
                  SOUND 500, 2: k = 2
                ELSEIF nome$ = "" THEN
                  SOUND 500, 2: k = 3
                ELSE
                  pag5 = TRUE
                  EXIT SUB
                END IF
            CASE F1
                CALL help
                IF k = 1 THEN
                  k = 0
                ELSE
                  k = k - 1
                END IF
            CASE FUP
                IF k > 1 THEN
                  k = k - 2
                ELSEIF k = 1 THEN
                  k = 6
                END IF
          END SELECT
        END SELECT
      LOOP UNTIL k = 7
    LOOP UNTIL PRIMO = 0 AND (SECONDO = PAGEDOWN OR SECONDO = PAGEUP)
  LOOP
pag5 = TRUE
END SUB

SUB PARABOLE (Q(), MS(), MD(), l(), nca, ncc, sx, sy, nome$, tratto$, taglio1$, delta, syt, tempo$)

  DIM i AS INTEGER, z AS INTEGER
  tempo1$ = TIME$
  TIME$ = "00:00:00"
  REDIM xc(nca)
  a$ = nome$ + ".DXB"
  header$ = "AutoCAD DXB 1.0" + CHR$(13) + CHR$(10) + CHR$(26) + CHR$(0) + CHR$(128)
  'l'ultimo byte di header$ si riferisce al comando SCALE FACTOR
  scala# = .01
  KILL a$
  OPEN a$ FOR BINARY AS #1
  IF sx < 20 THEN
    inc1 = .01
  ELSEIF sx < 50 THEN
    inc1 = .02
  ELSEIF sx < 100 THEN
    inc1 = .05
  ELSE
    inc1 = .1
  END IF
  IF sx < 50 THEN
    inc2 = .5 * sx / 100
  ELSE
    inc2 = .25 * sx / 100
  END IF
  ic1 = .98 * inc1
  sy = 1 / sy
  IF taglio1$ = "S" THEN syt = 1 / syt
  sx = 1 / sx
  yc = 50
  xc(1) = 0
  FOR i = 2 TO nca
    xc(i) = l(i - 1) * sx * 100 + xc(i - 1)
  NEXT i
'INTESTAZIONE DEL FILE DATI PER AUTOCAD:
  PUT #1, , header$
  PUT #1, , scala#
'INIZIO DEL DISEGNO DEL DIAGRAMMA DEI MOMENTI:

'    ***************** DISEGNA L'ASSE DEL DIAGRAMMA: *******************
  CALL linea(xc(1), yc, (l(nca) * sx * 100 + xc(nca)), yc)
  FOR i = 1 TO nca
    FOR z = 1 TO ncc
'    *********************  DISEGNA LE PARABOLE: ***********************
      x1 = xc(i)
      y1 = -MS(i, z) * sy + yc
      FOR x = inc1 TO l(i) + ic1 STEP inc1
        IF x > l(i) THEN x = l(i)
        y = -(((MD(i, z) - MS(i, z)) / l(i) + Q(i, z) * l(i) / 2) * x + MS(i, z) - Q(i, z) * x ^ 2 / 2)
        y2 = y * sy + yc
        x2 = x * sx * 100 + xc(i)
        CALL linea(x1, y1, x2, y2)
        x1 = x2
        y1 = y2
      NEXT x
      IF UCASE$(tratto$) = "S" THEN
'    ********* DISEGNA IL TRATTEGGIO VERTICALE DELLE PARABOLE: ********
        FOR x = inc2 TO l(i) STEP inc2
          y = -(((MD(i, z) - MS(i, z)) / l(i) + Q(i, z) * l(i) / 2) * x + MS(i, z) - Q(i, z) * x ^ 2 / 2)
          y2 = y * sy + yc
          x2 = x * sx * 100 + xc(i)
          CALL linea(x2, yc, x2, y2)
        NEXT x
      END IF
'    ************** DISEGNA LA PRIMA ORDINATA DELLA CAMPATA: **********
      CALL linea(xc(i), yc, xc(i), (-MS(i, z) * sy + yc))
'    ******************* DISEGNA L'ULTIMA ORDINATA: *******************
      CALL linea((l(i) * sx * 100 + xc(i)), yc, (l(i) * sx * 100 + xc(i)), (-MD(i, z) * sy + yc))
    NEXT z
  NEXT i
  IF taglio1$ = "S" THEN
    yc = 50 - delta
'INIZIO DISEGNO DEL DIAGRAMMA DEL TAGLIO:
'    ****************** DISEGNA L'ASSE DEL DIAGRAMMA: *****************
    CALL linea(xc(1), yc, (l(nca) * sx * 100 + xc(nca)), yc)
    FOR i = 1 TO nca
      FOR z = 1 TO ncc
'    ****************** DISEGNA LE RETTE DEL TAGLIO: ******************
        ta = (MD(i, z) - MS(i, z)) / l(i) + Q(i, z) * l(i) / 2
        tb = ta - Q(i, z) * l(i)
        x1 = xc(i)
        y1 = ta * syt + yc
        x2 = xc(i) + l(i) * 100 * sx
        y2 = tb * syt + yc
        CALL linea(x1, y1, x2, y2)
        IF UCASE$(tratto$) = "S" THEN
'    **** DISEGNA IL TRATTEGGIO VERTICALE DELLE RETTE DEL TAGLIO: *****
          FOR x = inc2 TO l(i) STEP inc2
            x2 = x * 100 * sx + xc(i)
            y2 = (ta - Q(i, z) * x) * syt + yc
            CALL linea(x2, yc, x2, y2)
          NEXT x
        END IF
'    ************* DISEGNA LA PRIMA ORDINATA DELLA CAMPATA ************
        x1 = xc(i)
        y1 = ta * syt + yc
        x2 = xc(i) + l(i) * 100 * sx
        y2 = tb * syt + yc
        CALL linea(x1, yc, x1, y1)
'    ******************* DISEGNA ULTIMA ORDINATA: *********************
        CALL linea(x2, yc, x2, y2)
      NEXT z
    NEXT i
  END IF
'CHIUSURA FILE DATI PER AUTOCAD:
  header$ = CHR$(0)
  PUT #1, , header$
  CLOSE 1
  tempo$ = TIME$
  TIME$ = tempo1$
END SUB

SUB puttext (xl%, yl%, xr%, yr%, buf%())
DEFINT I-L
  DEF SEG = 64
  DEF SEG = (47104 + 2048 * ((PEEK(16) AND 48) = 48))
  k = 1
  FOR i = yl% TO yr%
  FOR j = xl% TO xr%
    l = 160 * (i - 1) + 2 * (j - 1)
    POKE l, buf%(k) AND 255
    POKE l + 1, INT(buf%(k) / 256)
    k = k + 1
  NEXT j, i
END SUB

DEFSNG I-L
SUB TASTI
  LOCATE 23, 27, 0: PRINT " Premi "; CHR$(17) + CHR$(196) + CHR$(217); " per continuare ";
  DO
    DO
      a$ = INKEY$
    LOOP UNTIL a$ <> ""
  LOOP UNTIL ASC(a$) = 13
END SUB

